//Student's t regression model
//Coded by Alex Stead, m2i Research Fellow in Efficiency Analysis
//Institute for Transport Studies, University of Leeds
//Email: a.d.stead@leeds.ac.uk
//Version: 25/01/2017

//This programme enables the estimation of a regression model in which the errors
//follow a non-standard Student's t distribution with a scaling parameter.

program tregress, eclass
version 13.1
if !replay() {
syntax varlist(numeric ts) [if] [in] [, Level(cilevel)]
marksample touse
gettoken yvar xvars : varlist
ml model d1 tregress_ll (mu:`yvar'=`xvars') /lnsigma /lndf, title(Student's t regression model) diparm(lnsigma, exp label(sigma) prob) diparm(lndf, exp label(df) prob)
quietly regress `yvar' `xvars'
matrix b0 = e(b)
ml init b0
ml maximize, difficult
}
tempname b V y
matrix `b'				=	e(b)
matrix `V'				=	e(V)
ereturn post `b' `V', esample(`touse')
ereturn local predict 	"tregress_p"
ereturn local cmd		"tregress"
global ML_y1 `yvar'
end
